/* clock.c generated by valac 0.56.17, the Vala compiler
 * generated from clock.vala, do not modify */

/*
 * vala-panel
 * Copyright (C) 2015 Konstantin Pugin <ria.freelander@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "clock.h"
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include "applet-widget.h"
#include "toplevel.h"
#include <gio/gio.h>
#include "applet-widget-api.h"
#include "misc-gtk.h"
#include "css.h"
#include "generic-config-dialog.h"
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include "definitions.h"
#include "panel-platform.h"
#include "applet-info.h"

#define CLOCK_TIP_FORMAT "tooltip-format"
#define CLOCK_LABEL_FORMAT "clock-format"
#define CLOCK_BOLD "bold-font"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

typedef enum  {
	CLOCK_INTERVAL_AWAITING_FIRST_CHANGE = 0,
	CLOCK_INTERVAL_AWAITING_SECOND_CHANGE = 1,
	CLOCK_INTERVAL_ONE_SECOND = 2,
	CLOCK_INTERVAL_ONE_MINUTE = 3
} ClockInterval;

#define CLOCK_TYPE_INTERVAL (clock_interval_get_type ())
enum  {
	CLOCK_0_PROPERTY,
	CLOCK_CLOCK_FORMAT_PROPERTY,
	CLOCK_TOOLTIP_FORMAT_PROPERTY,
	CLOCK_BOLD_FONT_PROPERTY,
	CLOCK_NUM_PROPERTIES
};
static GParamSpec* clock_properties[CLOCK_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _ClockPrivate {
	GtkToggleButton* clock;
	ClockInterval exp_interval;
	gint exp_count;
	gchar* prev_clock_val;
	guint timer;
	GtkWindow* calendar;
	gchar* _clock_format;
	gchar* _tooltip_format;
	gboolean _bold_font;
};

static gint Clock_private_offset;
static gpointer clock_parent_class = NULL;
static GType clock_type_id = 0;

static GType clock_interval_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void clock_real_constructed (GObject* base);
static void __lambda4_ (Clock* self);
static GtkWindow* clock_create_calendar (Clock* self);
static void ___lambda4__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                            gpointer self);
static void __lambda5_ (Clock* self,
                 GParamSpec* pspec);
static gchar* clock_get_css (Clock* self);
static void clock_timer_set (Clock* self,
                      GDateTime* current_time);
static void ___lambda5__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static GtkWidget* clock_real_get_settings_ui (ValaPanelApplet* base);
static void clock_popup_position_helper (Clock* self,
                                  GtkWidget* popup,
                                  gint* x,
                                  gint* y);
static void clock_set_popup_position (Clock* self,
                               GtkWidget* popup);
VALA_EXTERN gboolean clock_get_bold_font (Clock* self);
static gboolean clock_update_display (Clock* self);
VALA_EXTERN const gchar* clock_get_clock_format (Clock* self);
VALA_EXTERN const gchar* clock_get_tooltip_format (Clock* self);
static gboolean _clock_update_display_gsource_func (gpointer self);
VALA_EXTERN void clock_set_clock_format (Clock* self,
                             const gchar* value);
VALA_EXTERN void clock_set_tooltip_format (Clock* self,
                               const gchar* value);
VALA_EXTERN void clock_set_bold_font (Clock* self,
                          gboolean value);
static void clock_finalize (GObject * obj);
static void _vala_clock_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec);
static void _vala_clock_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec);

static inline gpointer
clock_get_instance_private (Clock* self)
{
	return G_STRUCT_MEMBER_P (self, Clock_private_offset);
}

static GType
clock_interval_get_type_once (void)
{
	static const GEnumValue values[] = {{CLOCK_INTERVAL_AWAITING_FIRST_CHANGE, "CLOCK_INTERVAL_AWAITING_FIRST_CHANGE", "awaiting-first-change"}, {CLOCK_INTERVAL_AWAITING_SECOND_CHANGE, "CLOCK_INTERVAL_AWAITING_SECOND_CHANGE", "awaiting-second-change"}, {CLOCK_INTERVAL_ONE_SECOND, "CLOCK_INTERVAL_ONE_SECOND", "one-second"}, {CLOCK_INTERVAL_ONE_MINUTE, "CLOCK_INTERVAL_ONE_MINUTE", "one-minute"}, {0, NULL, NULL}};
	GType clock_interval_type_id;
	clock_interval_type_id = g_enum_register_static ("ClockInterval", values);
	return clock_interval_type_id;
}

static GType
clock_interval_get_type (void)
{
	static volatile gsize clock_interval_type_id__once = 0;
	if (g_once_init_enter (&clock_interval_type_id__once)) {
		GType clock_interval_type_id;
		clock_interval_type_id = clock_interval_get_type_once ();
		g_once_init_leave (&clock_interval_type_id__once, clock_interval_type_id);
	}
	return clock_interval_type_id__once;
}

Clock*
clock_construct (GType object_type,
                 ValaPanelToplevel* toplevel,
                 GSettings* settings,
                 const gchar* number)
{
	Clock * self = NULL;
	g_return_val_if_fail (toplevel != NULL, NULL);
	g_return_val_if_fail (number != NULL, NULL);
	self = (Clock*) vala_panel_applet_construct (object_type, toplevel, settings, number);
	return self;
}

Clock*
clock_new (ValaPanelToplevel* toplevel,
           GSettings* settings,
           const gchar* number)
{
	return clock_construct (TYPE_CLOCK, toplevel, settings, number);
}

static void
__lambda4_ (Clock* self)
{
	GtkToggleButton* _tmp0_;
	_tmp0_ = self->priv->clock;
	if (gtk_toggle_button_get_active (_tmp0_)) {
		GtkWindow* _tmp1_;
		GtkWindow* _tmp2_;
		_tmp1_ = clock_create_calendar (self);
		_g_object_unref0 (self->priv->calendar);
		self->priv->calendar = _tmp1_;
		_tmp2_ = self->priv->calendar;
		gtk_widget_show ((GtkWidget*) _tmp2_);
	} else {
		GtkWindow* _tmp3_;
		_tmp3_ = self->priv->calendar;
		gtk_widget_destroy ((GtkWidget*) _tmp3_);
		_g_object_unref0 (self->priv->calendar);
		self->priv->calendar = NULL;
	}
}

static void
___lambda4__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                       gpointer self)
{
	__lambda4_ ((Clock*) self);
}

static void
__lambda5_ (Clock* self,
            GParamSpec* pspec)
{
	const gchar* _tmp0_;
	g_return_if_fail (pspec != NULL);
	_tmp0_ = pspec->name;
	if (g_strcmp0 (_tmp0_, CLOCK_BOLD) == 0) {
		GtkToggleButton* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp1_ = self->priv->clock;
		_tmp2_ = clock_get_css (self);
		_tmp3_ = _tmp2_;
		css_apply_with_class ((GtkWidget*) _tmp1_, _tmp3_, "-vala-panel-font-weight", FALSE);
		_g_free0 (_tmp3_);
	} else {
		GDateTime* now = NULL;
		GDateTime* _tmp4_;
		GDateTime* _tmp5_;
		GtkWindow* _tmp6_;
		if (self->priv->timer != ((guint) 0)) {
			g_source_remove (self->priv->timer);
		}
		_g_free0 (self->priv->prev_clock_val);
		self->priv->prev_clock_val = NULL;
		self->priv->exp_count = 0;
		self->priv->exp_interval = CLOCK_INTERVAL_AWAITING_FIRST_CHANGE;
		_tmp4_ = g_date_time_new_now_local ();
		now = _tmp4_;
		_tmp5_ = now;
		clock_timer_set (self, _tmp5_);
		_tmp6_ = self->priv->calendar;
		if (_tmp6_ != NULL) {
			GtkWindow* _tmp7_;
			_tmp7_ = self->priv->calendar;
			gtk_widget_destroy ((GtkWidget*) _tmp7_);
			_g_object_unref0 (self->priv->calendar);
			self->priv->calendar = NULL;
		}
		_g_date_time_unref0 (now);
	}
}

static void
___lambda5__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda5_ ((Clock*) self, pspec);
}

static void
clock_real_constructed (GObject* base)
{
	Clock * self;
	GSimpleActionGroup* _tmp0_;
	GSimpleActionGroup* _tmp1_;
	GAction* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	GtkToggleButton* _tmp9_;
	GtkToggleButton* _tmp10_;
	GtkToggleButton* _tmp11_;
	GtkToggleButton* _tmp12_;
	GtkToggleButton* _tmp13_;
	self = (Clock*) base;
	_tmp0_ = vala_panel_applet_get_action_group ((ValaPanelApplet*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_action_map_lookup_action ((GActionMap*) _tmp1_, VALA_PANEL_APPLET_ACTION_CONFIGURE);
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp2_) : NULL, TRUE);
	_tmp3_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
	_tmp4_ = _tmp3_;
	g_settings_bind (_tmp4_, CLOCK_LABEL_FORMAT, (GObject*) self, CLOCK_LABEL_FORMAT, G_SETTINGS_BIND_GET);
	_tmp5_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
	_tmp6_ = _tmp5_;
	g_settings_bind (_tmp6_, CLOCK_TIP_FORMAT, (GObject*) self, CLOCK_TIP_FORMAT, G_SETTINGS_BIND_GET);
	_tmp7_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
	_tmp8_ = _tmp7_;
	g_settings_bind (_tmp8_, CLOCK_BOLD, (GObject*) self, CLOCK_BOLD, G_SETTINGS_BIND_GET);
	_tmp9_ = (GtkToggleButton*) gtk_toggle_button_new ();
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->clock);
	self->priv->clock = _tmp9_;
	_tmp10_ = self->priv->clock;
	vala_panel_setup_button (G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, gtk_button_get_type ()) ? ((GtkButton*) _tmp10_) : NULL, NULL, NULL);
	_tmp11_ = self->priv->clock;
	g_signal_connect_object (_tmp11_, "toggled", (GCallback) ___lambda4__gtk_toggle_button_toggled, self, 0);
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) ___lambda5__g_object_notify, self, 0);
	_tmp12_ = self->priv->clock;
	gtk_widget_show ((GtkWidget*) _tmp12_);
	_tmp13_ = self->priv->clock;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp13_);
	gtk_widget_show ((GtkWidget*) self);
}

static GtkWidget*
clock_real_get_settings_ui (ValaPanelApplet* base)
{
	Clock * self;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* result;
	self = (Clock*) base;
	_tmp0_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = generic_config_widget (_tmp1_, _ ("Clock Format"), CLOCK_LABEL_FORMAT, CONF_STR, _ ("Tooltip Format"), CLOCK_TIP_FORMAT, CONF_STR, _ ("Format codes: man 3 strftime; %n for line break"), NULL, CONF_TRIM, _ ("Bold font"), CLOCK_BOLD, CONF_BOOL, NULL);
	result = _tmp2_;
	return result;
}

static void
clock_popup_position_helper (Clock* self,
                             GtkWidget* popup,
                             gint* x,
                             gint* y)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
	GtkAllocation pa = {0};
	GtkAllocation a = {0};
	GtkAllocation _tmp0_ = {0};
	GtkAllocation _tmp10_ = {0};
	GdkWindow* _tmp11_;
	gint _tmp12_ = 0;
	gint _tmp13_ = 0;
	GtkPositionType edge = 0;
	ValaPanelToplevel* _tmp16_;
	ValaPanelToplevel* _tmp17_;
	PanelGravity _tmp18_;
	PanelGravity _tmp19_;
	GdkMonitor* monitor = NULL;
	GdkDisplay* _tmp24_;
	GdkMonitor* _tmp25_;
	GdkRectangle _tmp26_ = {0};
	GtkAllocation _tmp27_;
	GtkAllocation _tmp28_;
	GtkAllocation _tmp29_;
	GtkAllocation _tmp30_;
	GtkAllocation _tmp31_;
	GtkAllocation _tmp32_;
	GtkAllocation _tmp33_;
	GtkAllocation _tmp34_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (popup != NULL);
	gtk_widget_realize (popup);
	gtk_widget_get_allocation (popup, &_tmp0_);
	pa = _tmp0_;
	if (gtk_widget_is_toplevel (popup)) {
		GdkRectangle ext = {0};
		GdkWindow* _tmp1_;
		GdkRectangle _tmp2_ = {0};
		GdkRectangle _tmp3_;
		GdkRectangle _tmp4_;
		_tmp1_ = gtk_widget_get_window (popup);
		gdk_window_get_frame_extents (_tmp1_, &_tmp2_);
		ext = _tmp2_;
		_tmp3_ = ext;
		pa.width = _tmp3_.width;
		_tmp4_ = ext;
		pa.height = _tmp4_.height;
	}
	if (G_TYPE_CHECK_INSTANCE_TYPE (popup, gtk_menu_get_type ())) {
		gint min = 0;
		gint nat = 0;
		gint new_height = 0;
		GList* _tmp5_;
		GtkAllocation _tmp9_;
		new_height = 0;
		_tmp5_ = gtk_container_get_children ((GtkContainer*) (G_TYPE_CHECK_INSTANCE_TYPE (popup, gtk_menu_get_type ()) ? ((GtkMenu*) popup) : NULL));
		{
			GList* item_collection = NULL;
			GList* item_it = NULL;
			item_collection = _tmp5_;
			for (item_it = item_collection; item_it != NULL; item_it = item_it->next) {
				GtkWidget* item = NULL;
				item = (GtkWidget*) item_it->data;
				{
					GtkWidget* _tmp6_;
					gint _tmp7_ = 0;
					gint _tmp8_ = 0;
					_tmp6_ = item;
					gtk_widget_get_preferred_height (_tmp6_, &_tmp7_, &_tmp8_);
					min = _tmp7_;
					nat = _tmp8_;
					new_height += nat;
				}
			}
			(item_collection == NULL) ? NULL : (item_collection = (g_list_free (item_collection), NULL));
		}
		_tmp9_ = pa;
		pa.height = MAX (_tmp9_.height, new_height);
	}
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp10_);
	a = _tmp10_;
	_tmp11_ = gtk_widget_get_window ((GtkWidget*) self);
	gdk_window_get_origin (_tmp11_, &_tmp12_, &_tmp13_);
	_vala_x = _tmp12_;
	_vala_y = _tmp13_;
	if (!gtk_widget_get_has_window ((GtkWidget*) self)) {
		GtkAllocation _tmp14_;
		GtkAllocation _tmp15_;
		_tmp14_ = a;
		_vala_x = _vala_x + _tmp14_.x;
		_tmp15_ = a;
		_vala_y = _vala_y + _tmp15_.y;
	}
	_tmp16_ = vala_panel_applet_get_toplevel ((ValaPanelApplet*) self);
	_tmp17_ = _tmp16_;
	g_object_get (_tmp17_, "panel-gravity", &_tmp18_, NULL);
	_tmp19_ = _tmp18_;
	edge = vala_panel_edge_from_gravity (_tmp19_);
	switch (edge) {
		case GTK_POS_TOP:
		{
			GtkAllocation _tmp20_;
			_tmp20_ = a;
			_vala_y = _vala_y + _tmp20_.height;
			break;
		}
		case GTK_POS_BOTTOM:
		{
			GtkAllocation _tmp21_;
			_tmp21_ = pa;
			_vala_y = _vala_y - _tmp21_.height;
			break;
		}
		case GTK_POS_LEFT:
		{
			GtkAllocation _tmp22_;
			_tmp22_ = a;
			_vala_x = _vala_x + _tmp22_.width;
			break;
		}
		case GTK_POS_RIGHT:
		{
			GtkAllocation _tmp23_;
			_tmp23_ = pa;
			_vala_x = _vala_x - _tmp23_.width;
			break;
		}
		default:
		break;
	}
	_tmp24_ = gtk_widget_get_display ((GtkWidget*) self);
	_tmp25_ = gdk_display_get_monitor_at_point (_tmp24_, _vala_x, _vala_y);
	monitor = _tmp25_;
	gdk_monitor_get_workarea (monitor, &_tmp26_);
	a = (GtkAllocation) _tmp26_;
	_tmp27_ = a;
	_tmp28_ = a;
	_tmp29_ = a;
	_tmp30_ = pa;
	_vala_x = CLAMP (_vala_x, _tmp27_.x, (_tmp28_.x + _tmp29_.width) - _tmp30_.width);
	_tmp31_ = a;
	_tmp32_ = a;
	_tmp33_ = a;
	_tmp34_ = pa;
	_vala_y = CLAMP (_vala_y, _tmp31_.y, (_tmp32_.y + _tmp33_.height) - _tmp34_.height);
	if (x) {
		*x = _vala_x;
	}
	if (y) {
		*y = _vala_y;
	}
}

static void
clock_set_popup_position (Clock* self,
                          GtkWidget* popup)
{
	gint x = 0;
	gint y = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (popup != NULL);
	clock_popup_position_helper (self, popup, &_tmp0_, &_tmp1_);
	x = _tmp0_;
	y = _tmp1_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (popup, gtk_window_get_type ())) {
		gtk_window_move (G_TYPE_CHECK_INSTANCE_TYPE (popup, gtk_window_get_type ()) ? ((GtkWindow*) popup) : NULL, x, y);
	} else {
		GdkWindow* _tmp2_;
		_tmp2_ = gtk_widget_get_window (popup);
		gdk_window_move (_tmp2_, x, y);
	}
}

static gchar*
clock_get_css (Clock* self)
{
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->priv->_bold_font;
	if (_tmp1_) {
		_tmp0_ = "bold";
	} else {
		_tmp0_ = "normal";
	}
	_tmp2_ = g_strdup_printf (" font-weight: %s;\n", _tmp0_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strconcat (".-vala-panel-font-weight{\n", _tmp3_, NULL);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strconcat (_tmp5_, "}", NULL);
	_tmp7_ = _tmp6_;
	_g_free0 (_tmp5_);
	_g_free0 (_tmp3_);
	result = _tmp7_;
	return result;
}

static GtkWindow*
clock_create_calendar (Clock* self)
{
	GtkWindow* win = NULL;
	GtkWindow* _tmp0_;
	GtkCalendar* calendar = NULL;
	GtkCalendar* _tmp1_;
	GDateTime* now = NULL;
	GDateTime* _tmp2_;
	ValaPanelToplevel* _tmp3_;
	ValaPanelToplevel* _tmp4_;
	ValaPanelToplevel* _tmp5_;
	ValaPanelToplevel* _tmp6_;
	GtkWindow* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = (GtkWindow*) gtk_window_new (GTK_WINDOW_POPUP);
	g_object_ref_sink (_tmp0_);
	win = _tmp0_;
	gtk_window_set_default_size (win, 180, 180);
	gtk_container_set_border_width ((GtkContainer*) win, (guint) 5);
	_tmp1_ = (GtkCalendar*) gtk_calendar_new ();
	g_object_ref_sink (_tmp1_);
	calendar = _tmp1_;
	_tmp2_ = g_date_time_new_now_local ();
	now = _tmp2_;
	gtk_calendar_set_display_options (calendar, (GTK_CALENDAR_SHOW_WEEK_NUMBERS | GTK_CALENDAR_SHOW_DAY_NAMES) | GTK_CALENDAR_SHOW_HEADING);
	gtk_calendar_mark_day (calendar, (guint) g_date_time_get_day_of_month (now));
	gtk_container_add ((GtkContainer*) win, (GtkWidget*) calendar);
	gtk_window_set_type_hint (win, GDK_WINDOW_TYPE_HINT_UTILITY);
	_tmp3_ = vala_panel_applet_get_toplevel ((ValaPanelApplet*) self);
	_tmp4_ = _tmp3_;
	gtk_window_set_transient_for (win, (GtkWindow*) _tmp4_);
	_tmp5_ = vala_panel_applet_get_toplevel ((ValaPanelApplet*) self);
	_tmp6_ = _tmp5_;
	gtk_window_set_attached_to (win, (GtkWidget*) _tmp6_);
	gtk_widget_show ((GtkWidget*) calendar);
	clock_set_popup_position (self, (GtkWidget*) win);
	result = win;
	_g_date_time_unref0 (now);
	_g_object_unref0 (calendar);
	return result;
}

static gboolean
clock_update_display (Clock* self)
{
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
	GSource* _tmp1_;
	GDateTime* _tmp2_;
	gchar* label = NULL;
	GDateTime* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* tooltip = NULL;
	GDateTime* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	GtkToggleButton* _tmp9_;
	const gchar* _tmp10_;
	GtkToggleButton* _tmp11_;
	const gchar* _tmp12_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = g_date_time_new_now_local ();
	now = _tmp0_;
	_tmp1_ = g_main_current_source ();
	if (g_source_is_destroyed (_tmp1_)) {
		result = FALSE;
		_g_date_time_unref0 (now);
		return result;
	}
	_tmp2_ = now;
	clock_timer_set (self, _tmp2_);
	_tmp3_ = now;
	_tmp4_ = self->priv->_clock_format;
	_tmp5_ = g_date_time_format (_tmp3_, _tmp4_);
	label = _tmp5_;
	_tmp6_ = now;
	_tmp7_ = self->priv->_tooltip_format;
	_tmp8_ = g_date_time_format (_tmp6_, _tmp7_);
	tooltip = _tmp8_;
	_tmp9_ = self->priv->clock;
	_tmp10_ = label;
	gtk_button_set_label ((GtkButton*) _tmp9_, _tmp10_);
	_tmp11_ = self->priv->clock;
	_tmp12_ = tooltip;
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp11_, _tmp12_);
	if (self->priv->exp_interval < CLOCK_INTERVAL_ONE_SECOND) {
		const gchar* _tmp13_;
		_tmp13_ = self->priv->prev_clock_val;
		if (_tmp13_ == NULL) {
			const gchar* _tmp14_;
			gchar* _tmp15_;
			_tmp14_ = label;
			_tmp15_ = g_strdup (_tmp14_);
			_g_free0 (self->priv->prev_clock_val);
			self->priv->prev_clock_val = _tmp15_;
		} else {
			const gchar* _tmp16_;
			const gchar* _tmp17_;
			_tmp16_ = self->priv->prev_clock_val;
			_tmp17_ = label;
			if (g_strcmp0 (_tmp16_, _tmp17_) == 0) {
				self->priv->exp_count = self->priv->exp_count + 1;
				if (self->priv->exp_count > 3) {
					self->priv->exp_interval = CLOCK_INTERVAL_ONE_MINUTE;
					_g_free0 (self->priv->prev_clock_val);
					self->priv->prev_clock_val = NULL;
				}
			} else {
				if (self->priv->exp_interval == CLOCK_INTERVAL_AWAITING_FIRST_CHANGE) {
					const gchar* _tmp18_;
					gchar* _tmp19_;
					self->priv->exp_interval = CLOCK_INTERVAL_AWAITING_SECOND_CHANGE;
					self->priv->exp_count = 0;
					_tmp18_ = label;
					_tmp19_ = g_strdup (_tmp18_);
					_g_free0 (self->priv->prev_clock_val);
					self->priv->prev_clock_val = _tmp19_;
				} else {
					ClockInterval _tmp20_ = 0;
					if (self->priv->exp_count > 3) {
						_tmp20_ = CLOCK_INTERVAL_ONE_MINUTE;
					} else {
						_tmp20_ = CLOCK_INTERVAL_ONE_SECOND;
					}
					self->priv->exp_interval = _tmp20_;
					_g_free0 (self->priv->prev_clock_val);
					self->priv->prev_clock_val = NULL;
				}
			}
		}
	}
	result = FALSE;
	_g_free0 (tooltip);
	_g_free0 (label);
	_g_date_time_unref0 (now);
	return result;
}

static gboolean
_clock_update_display_gsource_func (gpointer self)
{
	gboolean result;
	result = clock_update_display ((Clock*) self);
	return result;
}

static void
clock_timer_set (Clock* self,
                 GDateTime* current_time)
{
	guint microseconds = 0U;
	g_return_if_fail (self != NULL);
	g_return_if_fail (current_time != NULL);
	microseconds = (guint) 1000000;
	microseconds = (guint) (1000000 - g_date_time_get_microsecond (current_time));
	if (self->priv->exp_interval == CLOCK_INTERVAL_ONE_MINUTE) {
		guint seconds = 0U;
		seconds = (guint) (60 - g_date_time_get_second (current_time));
		microseconds += seconds * 1000000;
	}
	if (microseconds <= ((guint) 0)) {
		microseconds = (guint) 1000000;
	}
	self->priv->timer = g_timeout_add_full (G_PRIORITY_DEFAULT, microseconds / 1000, _clock_update_display_gsource_func, g_object_ref (self), g_object_unref);
}

const gchar*
clock_get_clock_format (Clock* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_clock_format;
	result = _tmp0_;
	return result;
}

void
clock_set_clock_format (Clock* self,
                        const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = clock_get_clock_format (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_clock_format);
		self->priv->_clock_format = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, clock_properties[CLOCK_CLOCK_FORMAT_PROPERTY]);
	}
}

const gchar*
clock_get_tooltip_format (Clock* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_tooltip_format;
	result = _tmp0_;
	return result;
}

void
clock_set_tooltip_format (Clock* self,
                          const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = clock_get_tooltip_format (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_tooltip_format);
		self->priv->_tooltip_format = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, clock_properties[CLOCK_TOOLTIP_FORMAT_PROPERTY]);
	}
}

gboolean
clock_get_bold_font (Clock* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_bold_font;
	return result;
}

void
clock_set_bold_font (Clock* self,
                     gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = clock_get_bold_font (self);
	if (old_value != value) {
		self->priv->_bold_font = value;
		g_object_notify_by_pspec ((GObject *) self, clock_properties[CLOCK_BOLD_FONT_PROPERTY]);
	}
}

static void
clock_class_init (ClockClass * klass,
                  gpointer klass_data)
{
	clock_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Clock_private_offset);
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) clock_real_constructed;
	((ValaPanelAppletClass *) klass)->get_settings_ui = (GtkWidget* (*) (ValaPanelApplet*)) clock_real_get_settings_ui;
	G_OBJECT_CLASS (klass)->get_property = _vala_clock_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_clock_set_property;
	G_OBJECT_CLASS (klass)->finalize = clock_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLOCK_CLOCK_FORMAT_PROPERTY, clock_properties[CLOCK_CLOCK_FORMAT_PROPERTY] = g_param_spec_string ("clock-format", "clock-format", "clock-format", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLOCK_TOOLTIP_FORMAT_PROPERTY, clock_properties[CLOCK_TOOLTIP_FORMAT_PROPERTY] = g_param_spec_string ("tooltip-format", "tooltip-format", "tooltip-format", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLOCK_BOLD_FONT_PROPERTY, clock_properties[CLOCK_BOLD_FONT_PROPERTY] = g_param_spec_boolean ("bold-font", "bold-font", "bold-font", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
clock_instance_init (Clock * self,
                     gpointer klass)
{
	self->priv = clock_get_instance_private (self);
}

static void
clock_finalize (GObject * obj)
{
	Clock * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CLOCK, Clock);
	_g_object_unref0 (self->priv->clock);
	_g_free0 (self->priv->prev_clock_val);
	_g_object_unref0 (self->priv->calendar);
	_g_free0 (self->priv->_clock_format);
	_g_free0 (self->priv->_tooltip_format);
	G_OBJECT_CLASS (clock_parent_class)->finalize (obj);
}

GType
clock_get_type (void)
{
	return clock_type_id;
}

GType
clock_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClockClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) clock_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Clock), 0, (GInstanceInitFunc) clock_instance_init, NULL };
	clock_type_id = g_type_module_register_type (module, VALA_PANEL_TYPE_APPLET, "Clock", &g_define_type_info, 0);
	Clock_private_offset = sizeof (ClockPrivate);
	return clock_type_id;
}

static void
_vala_clock_get_property (GObject * object,
                          guint property_id,
                          GValue * value,
                          GParamSpec * pspec)
{
	Clock * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CLOCK, Clock);
	switch (property_id) {
		case CLOCK_CLOCK_FORMAT_PROPERTY:
		g_value_set_string (value, clock_get_clock_format (self));
		break;
		case CLOCK_TOOLTIP_FORMAT_PROPERTY:
		g_value_set_string (value, clock_get_tooltip_format (self));
		break;
		case CLOCK_BOLD_FONT_PROPERTY:
		g_value_set_boolean (value, clock_get_bold_font (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_clock_set_property (GObject * object,
                          guint property_id,
                          const GValue * value,
                          GParamSpec * pspec)
{
	Clock * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CLOCK, Clock);
	switch (property_id) {
		case CLOCK_CLOCK_FORMAT_PROPERTY:
		clock_set_clock_format (self, g_value_get_string (value));
		break;
		case CLOCK_TOOLTIP_FORMAT_PROPERTY:
		clock_set_tooltip_format (self, g_value_get_string (value));
		break;
		case CLOCK_BOLD_FONT_PROPERTY:
		clock_set_bold_font (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

void
g_io_clock_load (GTypeModule* module)
{
	g_return_if_fail (module != NULL);
	clock_register_type (module);
	g_io_extension_point_implement (VALA_PANEL_APPLET_EXTENSION_POINT, TYPE_CLOCK, "org.valapanel.clock", 10);
}

void
g_io_clock_unload (GIOModule* module)
{
	g_return_if_fail (module != NULL);
}

