/* dirmenu.c generated by valac 0.56.17, the Vala compiler
 * generated from dirmenu.vala, do not modify */

/*
 * vala-panel
 * Copyright (C) 2015 Konstantin Pugin <ria.freelander@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "dirmenu.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include "applet-widget.h"
#include "toplevel.h"
#include <gio/gio.h>
#include "applet-widget-api.h"
#include "misc-gtk.h"
#include <glib/gstdio.h>
#include <stdio.h>
#include <glib/gi18n-lib.h>
#include "generic-config-dialog.h"
#include "applet-info.h"

#define DIRMENU_DIR "dir-path"
#define DIRMENU_ICON "icon-name"
#define DIRMENU_LABEL "caption"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DIRMENU_0_PROPERTY,
	DIRMENU_DIR_PATH_PROPERTY,
	DIRMENU_CAPTION_PROPERTY,
	DIRMENU_ICON_NAME_PROPERTY,
	DIRMENU_NUM_PROPERTIES
};
static GParamSpec* dirmenu_properties[DIRMENU_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;

#define DIRMENU_TYPE_DIRECTORY_SORT (dirmenu_directory_sort_get_type ())
typedef struct _DirmenuDirectorySort DirmenuDirectorySort;
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block3Data Block3Data;
#define _dirmenu_directory_sort_free0(var) ((var == NULL) ? NULL : (var = (dirmenu_directory_sort_free (var), NULL)))

struct _DirmenuPrivate {
	gchar* _dir_path;
	gchar* _caption;
	gchar* _icon_name;
};

struct _Block1Data {
	int _ref_count_;
	Dirmenu* self;
	GtkMenuButton* button;
};

struct _Block2Data {
	int _ref_count_;
	Dirmenu* self;
	gchar* directory;
};

struct _DirmenuDirectorySort {
	gchar* dirname;
	gchar* collate_key;
};

struct _Block3Data {
	int _ref_count_;
	Block2Data * _data2_;
	GtkMenuItem* item;
};

static gint Dirmenu_private_offset;
static gpointer dirmenu_parent_class = NULL;
static GType dirmenu_type_id = 0;

static void dirmenu_real_constructed (GObject* base);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static GIcon* dirmenu_set_icon (Dirmenu* self);
VALA_EXTERN const gchar* dirmenu_get_caption (Dirmenu* self);
static GtkMenu* dirmenu_create_menu (Dirmenu* self,
                              const gchar* directory,
                              gboolean at_top);
VALA_EXTERN const gchar* dirmenu_get_dir_path (Dirmenu* self);
static void __lambda9_ (Block1Data* _data1_,
                 GParamSpec* pspec);
static void ___lambda9__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
VALA_EXTERN const gchar* dirmenu_get_icon_name (Dirmenu* self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static GType dirmenu_directory_sort_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static DirmenuDirectorySort* dirmenu_directory_sort_dup (const DirmenuDirectorySort* self);
static void dirmenu_directory_sort_free (DirmenuDirectorySort* self);
static void dirmenu_directory_sort_copy (const DirmenuDirectorySort* self,
                                  DirmenuDirectorySort* dest);
static void dirmenu_directory_sort_destroy (DirmenuDirectorySort* self);
static gint ______lambda4_ (DirmenuDirectorySort* a,
                     DirmenuDirectorySort* b);
static gint _______lambda4__gcompare_func (gconstpointer a,
                                    gconstpointer b);
static void _dirmenu_directory_sort_free0_ (gpointer var);
static inline void _g_slist_free__dirmenu_directory_sort_free0_ (GSList* self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void ____lambda5_ (Block3Data* _data3_);
static void _____lambda5__gtk_menu_item_select (GtkMenuItem* _sender,
                                         gpointer self);
static void ____lambda6_ (Block3Data* _data3_);
static void _____lambda6__gtk_menu_item_deselect (GtkMenuItem* _sender,
                                           gpointer self);
static void __lambda7_ (Block2Data* _data2_);
static void ___lambda7__gtk_menu_item_activate (GtkMenuItem* _sender,
                                         gpointer self);
static void __lambda8_ (Block2Data* _data2_);
static void dirmenu_launch_terminal (Dirmenu* self,
                              const gchar* dir);
static void ___lambda8__gtk_menu_item_activate (GtkMenuItem* _sender,
                                         gpointer self);
static gboolean dirmenu_real_button_release_event (GtkWidget* base,
                                            GdkEventButton* e);
static GtkWidget* dirmenu_real_get_settings_ui (ValaPanelApplet* base);
VALA_EXTERN void dirmenu_set_dir_path (Dirmenu* self,
                           const gchar* value);
VALA_EXTERN void dirmenu_set_caption (Dirmenu* self,
                          const gchar* value);
VALA_EXTERN void dirmenu_set_icon_name (Dirmenu* self,
                            const gchar* value);
static void dirmenu_finalize (GObject * obj);
static void _vala_dirmenu_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec);
static void _vala_dirmenu_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
dirmenu_get_instance_private (Dirmenu* self)
{
	return G_STRUCT_MEMBER_P (self, Dirmenu_private_offset);
}

Dirmenu*
dirmenu_construct (GType object_type,
                   ValaPanelToplevel* toplevel,
                   GSettings* settings,
                   const gchar* number)
{
	Dirmenu * self = NULL;
	g_return_val_if_fail (toplevel != NULL, NULL);
	g_return_val_if_fail (number != NULL, NULL);
	self = (Dirmenu*) vala_panel_applet_construct (object_type, toplevel, settings, number);
	return self;
}

Dirmenu*
dirmenu_new (ValaPanelToplevel* toplevel,
             GSettings* settings,
             const gchar* number)
{
	return dirmenu_construct (TYPE_DIRMENU, toplevel, settings, number);
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		Dirmenu* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->button);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static void
__lambda9_ (Block1Data* _data1_,
            GParamSpec* pspec)
{
	Dirmenu* self;
	const gchar* _tmp0_;
	const gchar* _tmp5_;
	const gchar* _tmp7_;
	self = _data1_->self;
	g_return_if_fail (pspec != NULL);
	_tmp0_ = pspec->name;
	if (g_strcmp0 (_tmp0_, DIRMENU_ICON) == 0) {
		GtkWidget* _tmp1_;
		GtkWidget* _tmp2_;
		GIcon* _tmp3_;
		GIcon* _tmp4_;
		_tmp1_ = gtk_button_get_image ((GtkButton*) _data1_->button);
		_tmp2_ = _tmp1_;
		_tmp3_ = dirmenu_set_icon (self);
		_tmp4_ = _tmp3_;
		gtk_image_set_from_gicon (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_image_get_type ()) ? ((GtkImage*) _tmp2_) : NULL, _tmp4_, (GtkIconSize) GTK_ICON_SIZE_INVALID);
		_g_object_unref0 (_tmp4_);
	}
	_tmp5_ = pspec->name;
	if (g_strcmp0 (_tmp5_, DIRMENU_LABEL) == 0) {
		const gchar* _tmp6_;
		_tmp6_ = self->priv->_caption;
		gtk_button_set_label ((GtkButton*) _data1_->button, _tmp6_);
	}
	_tmp7_ = pspec->name;
	if (g_strcmp0 (_tmp7_, DIRMENU_DIR) == 0) {
		const gchar* _tmp8_;
		GtkMenu* _tmp9_;
		GtkMenu* _tmp10_;
		_tmp8_ = self->priv->_dir_path;
		_tmp9_ = dirmenu_create_menu (self, _tmp8_, FALSE);
		_tmp10_ = _tmp9_;
		gtk_menu_button_set_popup (_data1_->button, (GtkWidget*) _tmp10_);
		_g_object_unref0 (_tmp10_);
	}
}

static void
___lambda9__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda9_ (self, pspec);
}

static void
dirmenu_real_constructed (GObject* base)
{
	Dirmenu * self;
	Block1Data* _data1_;
	GSimpleActionGroup* _tmp0_;
	GSimpleActionGroup* _tmp1_;
	GAction* _tmp2_;
	GtkMenuButton* _tmp3_;
	GtkImage* img = NULL;
	GtkImage* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
	GSettings* _tmp10_;
	GIcon* _tmp11_;
	GIcon* _tmp12_;
	ValaPanelToplevel* _tmp13_;
	ValaPanelToplevel* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	GtkMenu* _tmp17_;
	GtkMenu* _tmp18_;
	self = (Dirmenu*) base;
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = vala_panel_applet_get_action_group ((ValaPanelApplet*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_action_map_lookup_action ((GActionMap*) _tmp1_, VALA_PANEL_APPLET_ACTION_CONFIGURE);
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp2_) : NULL, TRUE);
	_tmp3_ = (GtkMenuButton*) gtk_menu_button_new ();
	g_object_ref_sink (_tmp3_);
	_data1_->button = _tmp3_;
	_tmp4_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp4_);
	img = _tmp4_;
	_tmp5_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
	_tmp6_ = _tmp5_;
	g_settings_bind (_tmp6_, DIRMENU_DIR, (GObject*) self, DIRMENU_DIR, G_SETTINGS_BIND_GET);
	_tmp7_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
	_tmp8_ = _tmp7_;
	g_settings_bind (_tmp8_, DIRMENU_ICON, (GObject*) self, DIRMENU_ICON, G_SETTINGS_BIND_GET);
	_tmp9_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
	_tmp10_ = _tmp9_;
	g_settings_bind (_tmp10_, DIRMENU_LABEL, (GObject*) self, DIRMENU_LABEL, G_SETTINGS_BIND_GET);
	_tmp11_ = dirmenu_set_icon (self);
	_tmp12_ = _tmp11_;
	_tmp13_ = vala_panel_applet_get_toplevel ((ValaPanelApplet*) self);
	_tmp14_ = _tmp13_;
	vala_panel_setup_icon (img, _tmp12_, _tmp14_, -1);
	_g_object_unref0 (_tmp12_);
	_tmp15_ = self->priv->_caption;
	vala_panel_setup_button (G_TYPE_CHECK_INSTANCE_TYPE (_data1_->button, gtk_button_get_type ()) ? ((GtkButton*) _data1_->button) : NULL, img, _tmp15_);
	_tmp16_ = self->priv->_dir_path;
	_tmp17_ = dirmenu_create_menu (self, _tmp16_, FALSE);
	_tmp18_ = _tmp17_;
	gtk_menu_button_set_popup (_data1_->button, (GtkWidget*) _tmp18_);
	_g_object_unref0 (_tmp18_);
	g_signal_connect_data ((GObject*) self, "notify", (GCallback) ___lambda9__g_object_notify, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _data1_->button);
	gtk_widget_show ((GtkWidget*) _data1_->button);
	gtk_widget_show ((GtkWidget*) self);
	_g_object_unref0 (img);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static GIcon*
dirmenu_set_icon (Dirmenu* self)
{
	GIcon* icon = NULL;
	GIcon* _tmp4_ = NULL;
	GIcon* _tmp5_;
	GIcon* _tmp6_;
	GIcon* _tmp8_;
	GError* _inner_error0_ = NULL;
	GIcon* result;
	g_return_val_if_fail (self != NULL, NULL);
	icon = NULL;
	{
		GIcon* _tmp0_ = NULL;
		const gchar* _tmp1_;
		GIcon* _tmp2_;
		GIcon* _tmp3_;
		_tmp1_ = self->priv->_icon_name;
		_tmp2_ = g_icon_new_for_string (_tmp1_, &_inner_error0_);
		_tmp0_ = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp3_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (icon);
		icon = _tmp3_;
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_inner_error0_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (icon);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_tmp5_ = icon;
	_tmp6_ = _g_object_ref0 (_tmp5_);
	_tmp4_ = _tmp6_;
	if (_tmp4_ == NULL) {
		GThemedIcon* _tmp7_;
		_tmp7_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("system-file-manager");
		_g_object_unref0 (_tmp4_);
		_tmp4_ = (GIcon*) _tmp7_;
	}
	_tmp8_ = _tmp4_;
	_tmp4_ = NULL;
	result = _tmp8_;
	_g_object_unref0 (_tmp4_);
	_g_object_unref0 (icon);
	return result;
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		Dirmenu* self;
		self = _data2_->self;
		_g_free0 (_data2_->directory);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

static gpointer
_dirmenu_directory_sort_dup0 (gpointer self)
{
	return self ? dirmenu_directory_sort_dup (self) : NULL;
}

static gint
______lambda4_ (DirmenuDirectorySort* a,
                DirmenuDirectorySort* b)
{
	GCompareFunc _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gint result;
	_tmp0_ = ((GCompareFunc) g_strcmp0);
	_tmp1_ = (*a).collate_key;
	_tmp2_ = (*b).collate_key;
	result = _tmp0_ (_tmp1_, _tmp2_);
	return result;
}

static gint
_______lambda4__gcompare_func (gconstpointer a,
                               gconstpointer b)
{
	gint result;
	result = ______lambda4_ ((DirmenuDirectorySort*) a, (DirmenuDirectorySort*) b);
	return result;
}

static void
_dirmenu_directory_sort_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (dirmenu_directory_sort_free (var), NULL));
}

static inline void
_g_slist_free__dirmenu_directory_sort_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) _dirmenu_directory_sort_free0_);
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		Dirmenu* self;
		self = _data3_->_data2_->self;
		_g_object_unref0 (_data3_->item);
		block2_data_unref (_data3_->_data2_);
		_data3_->_data2_ = NULL;
		g_slice_free (Block3Data, _data3_);
	}
}

static void
____lambda5_ (Block3Data* _data3_)
{
	Block2Data* _data2_;
	Dirmenu* self;
	GtkMenuItem* _tmp0_;
	GtkWidget* _tmp1_;
	_data2_ = _data3_->_data2_;
	self = _data2_->self;
	_tmp0_ = _data3_->item;
	_tmp1_ = gtk_menu_item_get_submenu (_tmp0_);
	if (_tmp1_ != NULL) {
		gchar* dpath = NULL;
		GtkMenuItem* _tmp2_;
		GtkWidget* _tmp3_;
		gconstpointer _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
		_tmp2_ = _data3_->item;
		_tmp3_ = gtk_menu_item_get_submenu (_tmp2_);
		_tmp4_ = g_object_get_data ((GObject*) _tmp3_, "path");
		_tmp5_ = g_strdup ((const gchar*) _tmp4_);
		dpath = _tmp5_;
		_tmp6_ = dpath;
		if (_tmp6_ == NULL) {
			GtkMenuItem* _tmp7_;
			GtkContainer* _tmp8_;
			gconstpointer _tmp9_;
			GtkMenuItem* _tmp10_;
			gconstpointer _tmp11_;
			gchar* _tmp12_;
			GtkMenuItem* _tmp13_;
			const gchar* _tmp14_;
			GtkMenu* _tmp15_;
			GtkMenu* _tmp16_;
			_tmp7_ = _data3_->item;
			_tmp8_ = gtk_widget_get_parent ((GtkWidget*) _tmp7_);
			_tmp9_ = g_object_get_data ((GObject*) _tmp8_, "path");
			_tmp10_ = _data3_->item;
			_tmp11_ = g_object_get_data ((GObject*) _tmp10_, "name");
			_tmp12_ = g_build_filename ((const gchar*) _tmp9_, (const gchar*) _tmp11_, NULL);
			_g_free0 (dpath);
			dpath = _tmp12_;
			_tmp13_ = _data3_->item;
			_tmp14_ = dpath;
			_tmp15_ = dirmenu_create_menu (self, _tmp14_, TRUE);
			_tmp16_ = _tmp15_;
			gtk_menu_item_set_submenu (_tmp13_, _tmp16_);
			_g_object_unref0 (_tmp16_);
		}
		_g_free0 (dpath);
	}
}

static void
_____lambda5__gtk_menu_item_select (GtkMenuItem* _sender,
                                    gpointer self)
{
	____lambda5_ (self);
}

static void
____lambda6_ (Block3Data* _data3_)
{
	Block2Data* _data2_;
	Dirmenu* self;
	GtkMenuItem* _tmp0_;
	GtkMenu* _tmp1_;
	GtkMenu* _tmp2_;
	_data2_ = _data3_->_data2_;
	self = _data2_->self;
	_tmp0_ = _data3_->item;
	_tmp1_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp1_);
	_tmp2_ = _tmp1_;
	gtk_menu_item_set_submenu (_tmp0_, _tmp2_);
	_g_object_unref0 (_tmp2_);
}

static void
_____lambda6__gtk_menu_item_deselect (GtkMenuItem* _sender,
                                      gpointer self)
{
	____lambda6_ (self);
}

static void
__lambda7_ (Block2Data* _data2_)
{
	Dirmenu* self;
	GError* _inner_error0_ = NULL;
	self = _data2_->self;
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		GdkDisplay* _tmp2_;
		GdkAppLaunchContext* _tmp3_;
		GdkAppLaunchContext* _tmp4_;
		_tmp1_ = g_filename_to_uri (_data2_->directory, NULL, &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = gdk_display_get_default ();
		_tmp3_ = gdk_display_get_app_launch_context (_tmp2_);
		_tmp4_ = _tmp3_;
		g_app_info_launch_default_for_uri (_tmp0_, (GAppLaunchContext*) _tmp4_, &_inner_error0_);
		_g_object_unref0 (_tmp4_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (_tmp0_);
			goto __catch0_g_error;
		}
		_g_free0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp5_ = stderr;
		_tmp6_ = e;
		_tmp7_ = _tmp6_->message;
		fprintf (_tmp5_, "%s", _tmp7_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
___lambda7__gtk_menu_item_activate (GtkMenuItem* _sender,
                                    gpointer self)
{
	__lambda7_ (self);
}

static void
__lambda8_ (Block2Data* _data2_)
{
	Dirmenu* self;
	self = _data2_->self;
	dirmenu_launch_terminal (self, _data2_->directory);
}

static void
___lambda8__gtk_menu_item_activate (GtkMenuItem* _sender,
                                    gpointer self)
{
	__lambda8_ (self);
}

static GtkMenu*
dirmenu_create_menu (Dirmenu* self,
                     const gchar* directory,
                     gboolean at_top)
{
	Block2Data* _data2_;
	gchar* _tmp0_;
	GtkMenu* menu = NULL;
	GtkMenu* _tmp1_;
	GtkMenu* _tmp2_;
	gchar* _tmp3_;
	GSList* dir_list = NULL;
	GDir* dir = NULL;
	GSList* _tmp26_;
	GtkMenuItem* item = NULL;
	GtkMenuItem* _tmp58_;
	GtkMenuItem* _tmp59_;
	GtkMenuItem* _tmp60_;
	GtkMenuItem* term = NULL;
	GtkMenuItem* _tmp61_;
	GtkMenuItem* _tmp62_;
	GtkMenuItem* _tmp63_;
	GtkMenu* _tmp78_;
	GError* _inner_error0_ = NULL;
	GtkMenu* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (directory != NULL, NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_tmp0_ = g_strdup (directory);
	_g_free0 (_data2_->directory);
	_data2_->directory = _tmp0_;
	_tmp1_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp1_);
	menu = _tmp1_;
	_tmp2_ = menu;
	_tmp3_ = g_strdup (_data2_->directory);
	g_object_set_data_full ((GObject*) _tmp2_, "path", _tmp3_, g_free);
	dir_list = NULL;
	dir = NULL;
	{
		GDir* _tmp4_ = NULL;
		GDir* _tmp5_;
		GDir* _tmp6_;
		gchar* name = NULL;
		_tmp5_ = g_dir_open (_data2_->directory, (guint) 0, &_inner_error0_);
		_tmp4_ = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp6_ = _tmp4_;
		_tmp4_ = NULL;
		_g_dir_close0 (dir);
		dir = _tmp6_;
		name = NULL;
		while (TRUE) {
			GDir* _tmp7_;
			const gchar* _tmp8_;
			gchar* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			_tmp7_ = dir;
			_tmp8_ = g_dir_read_name (_tmp7_);
			_tmp9_ = g_strdup (_tmp8_);
			_g_free0 (name);
			name = _tmp9_;
			_tmp10_ = name;
			if (!(_tmp10_ != NULL)) {
				break;
			}
			_tmp11_ = name;
			if (string_get (_tmp11_, (glong) 0) != '.') {
				gchar* full = NULL;
				const gchar* _tmp12_;
				gchar* _tmp13_;
				const gchar* _tmp14_;
				_tmp12_ = name;
				_tmp13_ = g_build_filename (_data2_->directory, _tmp12_, NULL);
				full = _tmp13_;
				_tmp14_ = full;
				if (g_file_test (_tmp14_, G_FILE_TEST_IS_DIR)) {
					DirmenuDirectorySort cur = {0};
					const gchar* _tmp15_;
					gchar* _tmp16_;
					DirmenuDirectorySort _tmp17_;
					const gchar* _tmp18_;
					gchar* _tmp19_;
					DirmenuDirectorySort _tmp20_;
					DirmenuDirectorySort _tmp21_;
					DirmenuDirectorySort* _tmp22_;
					memset (&cur, 0, sizeof (DirmenuDirectorySort));
					_tmp15_ = name;
					_tmp16_ = g_filename_display_name (_tmp15_);
					_g_free0 (cur.dirname);
					cur.dirname = _tmp16_;
					_tmp17_ = cur;
					_tmp18_ = _tmp17_.dirname;
					_tmp19_ = g_utf8_collate_key (_tmp18_, (gssize) -1);
					_g_free0 (cur.collate_key);
					cur.collate_key = _tmp19_;
					_tmp20_ = cur;
					_tmp21_ = _tmp20_;
					_tmp22_ = _dirmenu_directory_sort_dup0 (&_tmp21_);
					dir_list = g_slist_insert_sorted (dir_list, _tmp22_, _______lambda4__gcompare_func);
					dirmenu_directory_sort_destroy (&cur);
				}
				_g_free0 (full);
			}
		}
		_g_free0 (name);
		_g_dir_close0 (_tmp4_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp23_;
		GError* _tmp24_;
		const gchar* _tmp25_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp23_ = stderr;
		_tmp24_ = e;
		_tmp25_ = _tmp24_->message;
		fprintf (_tmp23_, "%s\n", _tmp25_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_dir_close0 (dir);
		(dir_list == NULL) ? NULL : (dir_list = (_g_slist_free__dirmenu_directory_sort_free0_ (dir_list), NULL));
		_g_object_unref0 (menu);
		block2_data_unref (_data2_);
		_data2_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_tmp26_ = dir_list;
	{
		GSList* cursor_collection = NULL;
		GSList* cursor_it = NULL;
		cursor_collection = _tmp26_;
		for (cursor_it = cursor_collection; cursor_it != NULL; cursor_it = cursor_it->next) {
			DirmenuDirectorySort* _tmp27_;
			DirmenuDirectorySort* cursor = NULL;
			_tmp27_ = _dirmenu_directory_sort_dup0 ((DirmenuDirectorySort*) cursor_it->data);
			cursor = _tmp27_;
			{
				Block3Data* _data3_;
				GtkMenuItem* _tmp28_;
				GtkBox* box = NULL;
				GtkBox* _tmp29_;
				GtkImage* img = NULL;
				GThemedIcon* _tmp30_;
				GThemedIcon* _tmp31_;
				GtkImage* _tmp32_;
				GtkImage* _tmp33_;
				GtkImage* _tmp34_;
				GtkBox* _tmp35_;
				GtkImage* _tmp36_;
				GtkLabel* lbl = NULL;
				DirmenuDirectorySort* _tmp37_;
				const gchar* _tmp38_;
				GtkLabel* _tmp39_;
				GtkBox* _tmp40_;
				GtkLabel* _tmp41_;
				GtkLabel* _tmp42_;
				GtkMenuItem* _tmp43_;
				GtkBox* _tmp44_;
				GtkBox* _tmp45_;
				GtkMenu* dummy = NULL;
				GtkMenu* _tmp46_;
				GtkMenuItem* _tmp47_;
				GtkMenu* _tmp48_;
				GtkMenuItem* _tmp49_;
				GtkMenu* _tmp50_;
				GtkMenuItem* _tmp51_;
				GtkMenuItem* _tmp52_;
				DirmenuDirectorySort* _tmp53_;
				const gchar* _tmp54_;
				gchar* _tmp55_;
				GtkMenuItem* _tmp56_;
				GtkMenuItem* _tmp57_;
				_data3_ = g_slice_new0 (Block3Data);
				_data3_->_ref_count_ = 1;
				_data3_->_data2_ = block2_data_ref (_data2_);
				_tmp28_ = (GtkMenuItem*) gtk_menu_item_new ();
				g_object_ref_sink (_tmp28_);
				_data3_->item = _tmp28_;
				_tmp29_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 10);
				g_object_ref_sink (_tmp29_);
				box = _tmp29_;
				_tmp30_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("folder-symbolic");
				_tmp31_ = _tmp30_;
				_tmp32_ = (GtkImage*) gtk_image_new_from_gicon ((GIcon*) _tmp31_, (GtkIconSize) GTK_ICON_SIZE_MENU);
				g_object_ref_sink (_tmp32_);
				_tmp33_ = _tmp32_;
				_g_object_unref0 (_tmp31_);
				img = _tmp33_;
				_tmp34_ = img;
				gtk_widget_show ((GtkWidget*) _tmp34_);
				_tmp35_ = box;
				_tmp36_ = img;
				gtk_box_pack_start (_tmp35_, (GtkWidget*) _tmp36_, FALSE, TRUE, (guint) 0);
				_tmp37_ = cursor;
				_tmp38_ = (*_tmp37_).dirname;
				_tmp39_ = (GtkLabel*) gtk_label_new (_tmp38_);
				g_object_ref_sink (_tmp39_);
				lbl = _tmp39_;
				_tmp40_ = box;
				_tmp41_ = lbl;
				gtk_box_pack_start (_tmp40_, (GtkWidget*) _tmp41_, FALSE, TRUE, (guint) 0);
				_tmp42_ = lbl;
				gtk_widget_show ((GtkWidget*) _tmp42_);
				_tmp43_ = _data3_->item;
				_tmp44_ = box;
				gtk_container_add ((GtkContainer*) _tmp43_, (GtkWidget*) _tmp44_);
				_tmp45_ = box;
				gtk_widget_show ((GtkWidget*) _tmp45_);
				_tmp46_ = (GtkMenu*) gtk_menu_new ();
				g_object_ref_sink (_tmp46_);
				dummy = _tmp46_;
				_tmp47_ = _data3_->item;
				_tmp48_ = dummy;
				gtk_menu_item_set_submenu (_tmp47_, _tmp48_);
				_tmp49_ = _data3_->item;
				gtk_widget_show ((GtkWidget*) _tmp49_);
				_tmp50_ = menu;
				_tmp51_ = _data3_->item;
				gtk_menu_shell_append ((GtkMenuShell*) _tmp50_, _tmp51_);
				_tmp52_ = _data3_->item;
				_tmp53_ = cursor;
				_tmp54_ = (*_tmp53_).dirname;
				_tmp55_ = g_strdup (_tmp54_);
				g_object_set_data_full ((GObject*) _tmp52_, "name", _tmp55_, g_free);
				_tmp56_ = _data3_->item;
				g_signal_connect_data (_tmp56_, "select", (GCallback) _____lambda5__gtk_menu_item_select, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
				_tmp57_ = _data3_->item;
				g_signal_connect_data (_tmp57_, "deselect", (GCallback) _____lambda6__gtk_menu_item_deselect, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
				_g_object_unref0 (dummy);
				_g_object_unref0 (lbl);
				_g_object_unref0 (img);
				_g_object_unref0 (box);
				_dirmenu_directory_sort_free0 (cursor);
				block3_data_unref (_data3_);
				_data3_ = NULL;
			}
		}
	}
	_tmp58_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("_Open"));
	g_object_ref_sink (_tmp58_);
	item = _tmp58_;
	_tmp59_ = item;
	g_signal_connect_data (_tmp59_, "activate", (GCallback) ___lambda7__gtk_menu_item_activate, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp60_ = item;
	gtk_widget_show ((GtkWidget*) _tmp60_);
	_tmp61_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("Open in _Terminal"));
	g_object_ref_sink (_tmp61_);
	term = _tmp61_;
	_tmp62_ = term;
	g_signal_connect_data (_tmp62_, "activate", (GCallback) ___lambda8__gtk_menu_item_activate, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp63_ = term;
	gtk_widget_show ((GtkWidget*) _tmp63_);
	if (at_top) {
		GtkMenu* _tmp64_;
		GtkSeparatorMenuItem* _tmp65_;
		GtkSeparatorMenuItem* _tmp66_;
		GtkMenu* _tmp67_;
		GtkMenuItem* _tmp68_;
		GtkMenu* _tmp69_;
		GtkMenuItem* _tmp70_;
		_tmp64_ = menu;
		_tmp65_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
		g_object_ref_sink (_tmp65_);
		_tmp66_ = _tmp65_;
		gtk_menu_shell_insert ((GtkMenuShell*) _tmp64_, (GtkWidget*) _tmp66_, 0);
		_g_object_unref0 (_tmp66_);
		_tmp67_ = menu;
		_tmp68_ = term;
		gtk_menu_shell_insert ((GtkMenuShell*) _tmp67_, (GtkWidget*) _tmp68_, 0);
		_tmp69_ = menu;
		_tmp70_ = item;
		gtk_menu_shell_insert ((GtkMenuShell*) _tmp69_, (GtkWidget*) _tmp70_, 0);
	} else {
		GtkMenu* _tmp71_;
		GtkSeparatorMenuItem* _tmp72_;
		GtkSeparatorMenuItem* _tmp73_;
		GtkMenu* _tmp74_;
		GtkMenuItem* _tmp75_;
		GtkMenu* _tmp76_;
		GtkMenuItem* _tmp77_;
		_tmp71_ = menu;
		_tmp72_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
		g_object_ref_sink (_tmp72_);
		_tmp73_ = _tmp72_;
		gtk_menu_shell_append ((GtkMenuShell*) _tmp71_, (GtkMenuItem*) _tmp73_);
		_g_object_unref0 (_tmp73_);
		_tmp74_ = menu;
		_tmp75_ = term;
		gtk_menu_shell_append ((GtkMenuShell*) _tmp74_, _tmp75_);
		_tmp76_ = menu;
		_tmp77_ = item;
		gtk_menu_shell_append ((GtkMenuShell*) _tmp76_, _tmp77_);
	}
	_tmp78_ = menu;
	gtk_widget_show ((GtkWidget*) _tmp78_);
	result = menu;
	_g_object_unref0 (term);
	_g_object_unref0 (item);
	_g_dir_close0 (dir);
	(dir_list == NULL) ? NULL : (dir_list = (_g_slist_free__dirmenu_directory_sort_free0_ (dir_list), NULL));
	block2_data_unref (_data2_);
	_data2_ = NULL;
	return result;
}

static void
dirmenu_launch_terminal (Dirmenu* self,
                         const gchar* dir)
{
	gchar* command = NULL;
	gchar* true_dir = NULL;
	gchar* _tmp0_;
	ValaPanelToplevel* _tmp1_;
	ValaPanelToplevel* _tmp2_;
	GtkApplication* _tmp3_;
	GtkApplication* _tmp4_;
	gchar* _tmp5_ = NULL;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (dir != NULL);
	_tmp0_ = g_strdup (dir);
	true_dir = _tmp0_;
	_tmp1_ = vala_panel_applet_get_toplevel ((ValaPanelApplet*) self);
	_tmp2_ = _tmp1_;
	_tmp3_ = gtk_window_get_application ((GtkWindow*) _tmp2_);
	_tmp4_ = _tmp3_;
	g_object_get ((GObject*) _tmp4_, "terminal-command", &_tmp5_, NULL);
	_g_free0 (command);
	command = _tmp5_;
	if (!g_path_is_absolute (dir)) {
		gchar* _tmp6_;
		_tmp6_ = realpath (dir, NULL);
		_g_free0 (true_dir);
		true_dir = _tmp6_;
	}
	{
		gchar** argv = NULL;
		const gchar* _tmp7_;
		gchar** _tmp8_;
		gchar** _tmp9_;
		gint argv_length1;
		gint _argv_size_;
		gchar** envp = NULL;
		gchar** _tmp10_;
		gchar** _tmp11_;
		const gchar* _tmp12_;
		gchar** _tmp13_;
		gchar** _tmp14_;
		gint envp_length1;
		gint _envp_size_;
		const gchar* _tmp15_;
		_tmp7_ = command;
		_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, " ", 0);
		argv = _tmp9_;
		argv_length1 = _vala_array_length (_tmp8_);
		_argv_size_ = argv_length1;
		_tmp11_ = _tmp10_ = g_get_environ ();
		_tmp12_ = true_dir;
		_tmp14_ = _tmp13_ = g_environ_setenv (_tmp11_, "PWD", _tmp12_, TRUE);
		envp = _tmp14_;
		envp_length1 = _vala_array_length (_tmp13_);
		_envp_size_ = envp_length1;
		_tmp15_ = true_dir;
		g_spawn_async (_tmp15_, argv, envp, G_SPAWN_SEARCH_PATH, NULL, NULL, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			envp = (_vala_array_free (envp, envp_length1, (GDestroyNotify) g_free), NULL);
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
			goto __catch0_g_error;
		}
		envp = (_vala_array_free (envp, envp_length1, (GDestroyNotify) g_free), NULL);
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp16_;
		GError* _tmp17_;
		const gchar* _tmp18_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp16_ = stderr;
		_tmp17_ = e;
		_tmp18_ = _tmp17_->message;
		fprintf (_tmp16_, "Cannot launch terminal: %s\n", _tmp18_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (true_dir);
		_g_free0 (command);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_free0 (true_dir);
	_g_free0 (command);
}

static gboolean
dirmenu_real_button_release_event (GtkWidget* base,
                                   GdkEventButton* e)
{
	Dirmenu * self;
	gboolean result;
	self = (Dirmenu*) base;
	g_return_val_if_fail (e != NULL, FALSE);
	if (e->button == ((guint) 2)) {
		const gchar* _tmp0_;
		_tmp0_ = self->priv->_dir_path;
		dirmenu_launch_terminal (self, _tmp0_);
	}
	result = FALSE;
	return result;
}

static GtkWidget*
dirmenu_real_get_settings_ui (ValaPanelApplet* base)
{
	Dirmenu * self;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* result;
	self = (Dirmenu*) base;
	_tmp0_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = generic_config_widget (_tmp1_, _ ("Directory"), DIRMENU_DIR, CONF_DIRECTORY, _ ("Label"), DIRMENU_LABEL, CONF_STR, _ ("Icon"), DIRMENU_ICON, CONF_FILE_ENTRY, NULL);
	result = _tmp2_;
	return result;
}

const gchar*
dirmenu_get_dir_path (Dirmenu* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_dir_path;
	result = _tmp0_;
	return result;
}

void
dirmenu_set_dir_path (Dirmenu* self,
                      const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = dirmenu_get_dir_path (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_dir_path);
		self->priv->_dir_path = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, dirmenu_properties[DIRMENU_DIR_PATH_PROPERTY]);
	}
}

const gchar*
dirmenu_get_caption (Dirmenu* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_caption;
	result = _tmp0_;
	return result;
}

void
dirmenu_set_caption (Dirmenu* self,
                     const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = dirmenu_get_caption (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_caption);
		self->priv->_caption = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, dirmenu_properties[DIRMENU_CAPTION_PROPERTY]);
	}
}

const gchar*
dirmenu_get_icon_name (Dirmenu* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_icon_name;
	result = _tmp0_;
	return result;
}

void
dirmenu_set_icon_name (Dirmenu* self,
                       const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = dirmenu_get_icon_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_icon_name);
		self->priv->_icon_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, dirmenu_properties[DIRMENU_ICON_NAME_PROPERTY]);
	}
}

static void
dirmenu_directory_sort_copy (const DirmenuDirectorySort* self,
                             DirmenuDirectorySort* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	_tmp0_ = (*self).dirname;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).dirname);
	(*dest).dirname = _tmp1_;
	_tmp2_ = (*self).collate_key;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).collate_key);
	(*dest).collate_key = _tmp3_;
}

static void
dirmenu_directory_sort_destroy (DirmenuDirectorySort* self)
{
	_g_free0 ((*self).dirname);
	_g_free0 ((*self).collate_key);
}

static DirmenuDirectorySort*
dirmenu_directory_sort_dup (const DirmenuDirectorySort* self)
{
	DirmenuDirectorySort* dup;
	dup = g_new0 (DirmenuDirectorySort, 1);
	dirmenu_directory_sort_copy (self, dup);
	return dup;
}

static void
dirmenu_directory_sort_free (DirmenuDirectorySort* self)
{
	dirmenu_directory_sort_destroy (self);
	g_free (self);
}

static GType
dirmenu_directory_sort_get_type_once (void)
{
	GType dirmenu_directory_sort_type_id;
	dirmenu_directory_sort_type_id = g_boxed_type_register_static ("DirmenuDirectorySort", (GBoxedCopyFunc) dirmenu_directory_sort_dup, (GBoxedFreeFunc) dirmenu_directory_sort_free);
	return dirmenu_directory_sort_type_id;
}

static GType
dirmenu_directory_sort_get_type (void)
{
	static volatile gsize dirmenu_directory_sort_type_id__once = 0;
	if (g_once_init_enter (&dirmenu_directory_sort_type_id__once)) {
		GType dirmenu_directory_sort_type_id;
		dirmenu_directory_sort_type_id = dirmenu_directory_sort_get_type_once ();
		g_once_init_leave (&dirmenu_directory_sort_type_id__once, dirmenu_directory_sort_type_id);
	}
	return dirmenu_directory_sort_type_id__once;
}

static void
dirmenu_class_init (DirmenuClass * klass,
                    gpointer klass_data)
{
	dirmenu_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Dirmenu_private_offset);
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) dirmenu_real_constructed;
	((GtkWidgetClass *) klass)->button_release_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) dirmenu_real_button_release_event;
	((ValaPanelAppletClass *) klass)->get_settings_ui = (GtkWidget* (*) (ValaPanelApplet*)) dirmenu_real_get_settings_ui;
	G_OBJECT_CLASS (klass)->get_property = _vala_dirmenu_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_dirmenu_set_property;
	G_OBJECT_CLASS (klass)->finalize = dirmenu_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIRMENU_DIR_PATH_PROPERTY, dirmenu_properties[DIRMENU_DIR_PATH_PROPERTY] = g_param_spec_string ("dir-path", "dir-path", "dir-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIRMENU_CAPTION_PROPERTY, dirmenu_properties[DIRMENU_CAPTION_PROPERTY] = g_param_spec_string ("caption", "caption", "caption", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIRMENU_ICON_NAME_PROPERTY, dirmenu_properties[DIRMENU_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
dirmenu_instance_init (Dirmenu * self,
                       gpointer klass)
{
	self->priv = dirmenu_get_instance_private (self);
}

static void
dirmenu_finalize (GObject * obj)
{
	Dirmenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DIRMENU, Dirmenu);
	_g_free0 (self->priv->_dir_path);
	_g_free0 (self->priv->_caption);
	_g_free0 (self->priv->_icon_name);
	G_OBJECT_CLASS (dirmenu_parent_class)->finalize (obj);
}

GType
dirmenu_get_type (void)
{
	return dirmenu_type_id;
}

GType
dirmenu_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (DirmenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dirmenu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Dirmenu), 0, (GInstanceInitFunc) dirmenu_instance_init, NULL };
	dirmenu_type_id = g_type_module_register_type (module, VALA_PANEL_TYPE_APPLET, "Dirmenu", &g_define_type_info, 0);
	Dirmenu_private_offset = sizeof (DirmenuPrivate);
	return dirmenu_type_id;
}

static void
_vala_dirmenu_get_property (GObject * object,
                            guint property_id,
                            GValue * value,
                            GParamSpec * pspec)
{
	Dirmenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DIRMENU, Dirmenu);
	switch (property_id) {
		case DIRMENU_DIR_PATH_PROPERTY:
		g_value_set_string (value, dirmenu_get_dir_path (self));
		break;
		case DIRMENU_CAPTION_PROPERTY:
		g_value_set_string (value, dirmenu_get_caption (self));
		break;
		case DIRMENU_ICON_NAME_PROPERTY:
		g_value_set_string (value, dirmenu_get_icon_name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_dirmenu_set_property (GObject * object,
                            guint property_id,
                            const GValue * value,
                            GParamSpec * pspec)
{
	Dirmenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DIRMENU, Dirmenu);
	switch (property_id) {
		case DIRMENU_DIR_PATH_PROPERTY:
		dirmenu_set_dir_path (self, g_value_get_string (value));
		break;
		case DIRMENU_CAPTION_PROPERTY:
		dirmenu_set_caption (self, g_value_get_string (value));
		break;
		case DIRMENU_ICON_NAME_PROPERTY:
		dirmenu_set_icon_name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

void
g_io_dirmenu_load (GTypeModule* module)
{
	g_return_if_fail (module != NULL);
	dirmenu_register_type (module);
	g_io_extension_point_implement (VALA_PANEL_APPLET_EXTENSION_POINT, TYPE_DIRMENU, "org.valapanel.dirmenu", 10);
}

void
g_io_dirmenu_unload (GIOModule* module)
{
	g_return_if_fail (module != NULL);
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

