/* wincmd.c generated by valac 0.56.17, the Vala compiler
 * generated from wincmd.vala, do not modify */

/*
 * vala-panel
 * Copyright (C) 2015 Konstantin Pugin <ria.freelander@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "wincmd.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include "applet-widget.h"
#include <gdk/gdk.h>
#include "toplevel.h"
#include <gio/gio.h>
#include "applet-widget-api.h"
#include <stdio.h>
#include "misc-gtk.h"
#include "generic-config-dialog.h"
#include <glib/gi18n-lib.h>
#include <libwnck/libwnck.h>
#include <gdk/gdkx.h>
#include "applet-info.h"

#define WINCMD_KEY_LEFT "left-button-command"
#define WINCMD_KEY_MIDDLE "middle-button-command"
#define WINCMD_KEY_TOGGLE "toggle-iconify-and-shade"
#define WINCMD_KEY_ICON "icon"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

typedef enum  {
	WINCMD_COMMAND_NONE = 0,
	WINCMD_COMMAND_ICONIFY = 1,
	WINCMD_COMMAND_SHADE = 2
} WincmdCommand;

#define WINCMD_TYPE_COMMAND (wincmd_command_get_type ())
enum  {
	WINCMD_0_PROPERTY,
	WINCMD_LEFT_BUTTON_COMMAND_PROPERTY,
	WINCMD_MIDDLE_BUTTON_COMMAND_PROPERTY,
	WINCMD_TOGGLE_ICONIFY_AND_SHADE_PROPERTY,
	WINCMD_ICON_PROPERTY,
	WINCMD_NUM_PROPERTIES
};
static GParamSpec* wincmd_properties[WINCMD_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _WincmdPrivate {
	GtkButton* button;
	GtkImage* image;
	gboolean toggle_state;
	WincmdCommand _left_button_command;
	WincmdCommand _middle_button_command;
	gboolean _toggle_iconify_and_shade;
	gchar* _icon;
};

static gint Wincmd_private_offset;
static gpointer wincmd_parent_class = NULL;
static GType wincmd_type_id = 0;

VALA_EXTERN GType wincmd_command_get_type (void) G_GNUC_CONST ;
static void wincmd_real_constructed (GObject* base);
VALA_EXTERN const gchar* wincmd_get_icon (Wincmd* self);
static void __lambda4_ (Wincmd* self);
static void wincmd_execute_command (Wincmd* self,
                             WincmdCommand command);
VALA_EXTERN WincmdCommand wincmd_get_left_button_command (Wincmd* self);
static void ___lambda4__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void __lambda5_ (Wincmd* self,
                 GParamSpec* pspec);
static void wincmd_update_icon (Wincmd* self);
static void ___lambda5__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static GtkWidget* wincmd_real_get_settings_ui (ValaPanelApplet* base);
VALA_EXTERN gboolean wincmd_get_toggle_iconify_and_shade (Wincmd* self);
static void wincmd_adjust_toggle_state (Wincmd* self);
static gboolean wincmd_real_button_release_event (GtkWidget* base,
                                           GdkEventButton* e);
VALA_EXTERN WincmdCommand wincmd_get_middle_button_command (Wincmd* self);
VALA_EXTERN void wincmd_set_left_button_command (Wincmd* self,
                                     WincmdCommand value);
VALA_EXTERN void wincmd_set_middle_button_command (Wincmd* self,
                                       WincmdCommand value);
VALA_EXTERN void wincmd_set_toggle_iconify_and_shade (Wincmd* self,
                                          gboolean value);
VALA_EXTERN void wincmd_set_icon (Wincmd* self,
                      const gchar* value);
static void wincmd_finalize (GObject * obj);
static void _vala_wincmd_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec);
static void _vala_wincmd_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec);

static inline gpointer
wincmd_get_instance_private (Wincmd* self)
{
	return G_STRUCT_MEMBER_P (self, Wincmd_private_offset);
}

static GType
wincmd_command_get_type_once (void)
{
	static const GEnumValue values[] = {{WINCMD_COMMAND_NONE, "WINCMD_COMMAND_NONE", "none"}, {WINCMD_COMMAND_ICONIFY, "WINCMD_COMMAND_ICONIFY", "iconify"}, {WINCMD_COMMAND_SHADE, "WINCMD_COMMAND_SHADE", "shade"}, {0, NULL, NULL}};
	GType wincmd_command_type_id;
	wincmd_command_type_id = g_enum_register_static ("WincmdCommand", values);
	return wincmd_command_type_id;
}

GType
wincmd_command_get_type (void)
{
	static volatile gsize wincmd_command_type_id__once = 0;
	if (g_once_init_enter (&wincmd_command_type_id__once)) {
		GType wincmd_command_type_id;
		wincmd_command_type_id = wincmd_command_get_type_once ();
		g_once_init_leave (&wincmd_command_type_id__once, wincmd_command_type_id);
	}
	return wincmd_command_type_id__once;
}

Wincmd*
wincmd_construct (GType object_type,
                  ValaPanelToplevel* toplevel,
                  GSettings* settings,
                  const gchar* number)
{
	Wincmd * self = NULL;
	g_return_val_if_fail (toplevel != NULL, NULL);
	g_return_val_if_fail (number != NULL, NULL);
	self = (Wincmd*) vala_panel_applet_construct (object_type, toplevel, settings, number);
	return self;
}

Wincmd*
wincmd_new (ValaPanelToplevel* toplevel,
            GSettings* settings,
            const gchar* number)
{
	return wincmd_construct (TYPE_WINCMD, toplevel, settings, number);
}

static void
__lambda4_ (Wincmd* self)
{
	WincmdCommand _tmp0_;
	_tmp0_ = self->priv->_left_button_command;
	wincmd_execute_command (self, _tmp0_);
}

static void
___lambda4__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
	__lambda4_ ((Wincmd*) self);
}

static void
__lambda5_ (Wincmd* self,
            GParamSpec* pspec)
{
	g_return_if_fail (pspec != NULL);
	wincmd_update_icon (self);
}

static void
___lambda5__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda5_ ((Wincmd*) self, pspec);
}

static void
wincmd_real_constructed (GObject* base)
{
	Wincmd * self;
	GSimpleActionGroup* _tmp0_;
	GSimpleActionGroup* _tmp1_;
	GAction* _tmp2_;
	GtkButton* _tmp3_;
	GtkImage* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	GSettings* _tmp12_;
	GIcon* gicon = NULL;
	GThemedIcon* _tmp13_;
	GtkImage* _tmp20_;
	GIcon* _tmp21_;
	ValaPanelToplevel* _tmp22_;
	ValaPanelToplevel* _tmp23_;
	GtkButton* _tmp24_;
	GtkImage* _tmp25_;
	GtkButton* _tmp26_;
	GtkImage* _tmp27_;
	GtkButton* _tmp28_;
	GtkButton* _tmp29_;
	GtkImage* _tmp30_;
	GtkButton* _tmp31_;
	GError* _inner_error0_ = NULL;
	self = (Wincmd*) base;
	_tmp0_ = vala_panel_applet_get_action_group ((ValaPanelApplet*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_action_map_lookup_action ((GActionMap*) _tmp1_, VALA_PANEL_APPLET_ACTION_CONFIGURE);
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp2_) : NULL, TRUE);
	_tmp3_ = (GtkButton*) gtk_button_new ();
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->button);
	self->priv->button = _tmp3_;
	_tmp4_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->image);
	self->priv->image = _tmp4_;
	_tmp5_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
	_tmp6_ = _tmp5_;
	g_settings_bind (_tmp6_, WINCMD_KEY_LEFT, (GObject*) self, WINCMD_KEY_LEFT, G_SETTINGS_BIND_GET);
	_tmp7_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
	_tmp8_ = _tmp7_;
	g_settings_bind (_tmp8_, WINCMD_KEY_MIDDLE, (GObject*) self, WINCMD_KEY_MIDDLE, G_SETTINGS_BIND_GET);
	_tmp9_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
	_tmp10_ = _tmp9_;
	g_settings_bind (_tmp10_, WINCMD_KEY_TOGGLE, (GObject*) self, WINCMD_KEY_TOGGLE, G_SETTINGS_BIND_GET);
	_tmp11_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
	_tmp12_ = _tmp11_;
	g_settings_bind (_tmp12_, WINCMD_KEY_ICON, (GObject*) self, WINCMD_KEY_ICON, G_SETTINGS_BIND_GET);
	_tmp13_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("preferences-desktop-wallpaper-symbolic");
	gicon = (GIcon*) _tmp13_;
	{
		GIcon* _tmp14_ = NULL;
		const gchar* _tmp15_;
		GIcon* _tmp16_;
		GIcon* _tmp17_;
		_tmp15_ = self->priv->_icon;
		_tmp16_ = g_icon_new_for_string (_tmp15_, &_inner_error0_);
		_tmp14_ = _tmp16_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp17_ = _tmp14_;
		_tmp14_ = NULL;
		_g_object_unref0 (gicon);
		gicon = _tmp17_;
		_g_object_unref0 (_tmp14_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		FILE* _tmp18_;
		GThemedIcon* _tmp19_;
		g_clear_error (&_inner_error0_);
		_tmp18_ = stderr;
		fprintf (_tmp18_, "Default icon will be used\n");
		_tmp19_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("preferences-desktop-wallpaper-symbolic");
		_g_object_unref0 (gicon);
		gicon = (GIcon*) _tmp19_;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (gicon);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp20_ = self->priv->image;
	_tmp21_ = gicon;
	_tmp22_ = vala_panel_applet_get_toplevel ((ValaPanelApplet*) self);
	_tmp23_ = _tmp22_;
	vala_panel_setup_icon (_tmp20_, _tmp21_, _tmp23_, -1);
	_tmp24_ = self->priv->button;
	_tmp25_ = self->priv->image;
	vala_panel_setup_button (_tmp24_, _tmp25_, NULL);
	_tmp26_ = self->priv->button;
	_tmp27_ = self->priv->image;
	gtk_button_set_image (_tmp26_, (GtkWidget*) _tmp27_);
	_tmp28_ = self->priv->button;
	g_signal_connect_object (_tmp28_, "clicked", (GCallback) ___lambda4__gtk_button_clicked, self, 0);
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) ___lambda5__g_object_notify, self, 0);
	_tmp29_ = self->priv->button;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp29_);
	_tmp30_ = self->priv->image;
	gtk_widget_show ((GtkWidget*) _tmp30_);
	_tmp31_ = self->priv->button;
	gtk_widget_show ((GtkWidget*) _tmp31_);
	gtk_widget_show ((GtkWidget*) self);
	_g_object_unref0 (gicon);
}

static GtkWidget*
wincmd_real_get_settings_ui (ValaPanelApplet* base)
{
	Wincmd * self;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* result;
	self = (Wincmd*) base;
	_tmp0_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = generic_config_widget (_tmp1_, _ ("Alternately iconify/shade and raise"), WINCMD_KEY_TOGGLE, CONF_BOOL, NULL);
	result = _tmp2_;
	return result;
}

static void
wincmd_update_icon (Wincmd* self)
{
	GIcon* gicon = NULL;
	GThemedIcon* _tmp0_;
	GtkImage* _tmp7_;
	GIcon* _tmp8_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("preferences-desktop-wallpaper-symbolic");
	gicon = (GIcon*) _tmp0_;
	{
		GIcon* _tmp1_ = NULL;
		const gchar* _tmp2_;
		GIcon* _tmp3_;
		GIcon* _tmp4_;
		_tmp2_ = self->priv->_icon;
		_tmp3_ = g_icon_new_for_string (_tmp2_, &_inner_error0_);
		_tmp1_ = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp4_ = _tmp1_;
		_tmp1_ = NULL;
		_g_object_unref0 (gicon);
		gicon = _tmp4_;
		_g_object_unref0 (_tmp1_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		FILE* _tmp5_;
		GThemedIcon* _tmp6_;
		g_clear_error (&_inner_error0_);
		_tmp5_ = stderr;
		fprintf (_tmp5_, "Default icon will be used\n");
		_tmp6_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("preferences-desktop-wallpaper-symbolic");
		_g_object_unref0 (gicon);
		gicon = (GIcon*) _tmp6_;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (gicon);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp7_ = self->priv->image;
	_tmp8_ = gicon;
	gtk_image_set_from_gicon (_tmp7_, _tmp8_, (GtkIconSize) GTK_ICON_SIZE_INVALID);
	_g_object_unref0 (gicon);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
wincmd_execute_command (Wincmd* self,
                        WincmdCommand command)
{
	WnckScreen* scr = NULL;
	WnckScreen* _tmp0_;
	WnckScreen* _tmp1_;
	WnckWorkspace* desk = NULL;
	WnckScreen* _tmp9_;
	WnckWorkspace* _tmp10_;
	WnckWorkspace* _tmp11_;
	WnckScreen* _tmp12_;
	GList* _tmp13_;
	g_return_if_fail (self != NULL);
	_tmp0_ = wnck_screen_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	scr = _tmp1_;
	if (command == WINCMD_COMMAND_ICONIFY) {
		GdkX11Screen* screen = NULL;
		GdkScreen* _tmp2_;
		GdkX11Screen* _tmp3_;
		GdkAtom atom = (GdkAtom) 0U;
		GdkX11Screen* _tmp4_;
		_tmp2_ = gtk_widget_get_screen ((GtkWidget*) self);
		_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gdk_x11_screen_get_type ()) ? ((GdkX11Screen*) _tmp2_) : NULL);
		screen = _tmp3_;
		atom = gdk_atom_intern ("_NET_SHOWING_DESKTOP", FALSE);
		_tmp4_ = screen;
		if (gdk_x11_screen_supports_net_wm_hint (_tmp4_, atom)) {
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_;
			gboolean showing_desktop = FALSE;
			WnckScreen* _tmp8_;
			_tmp7_ = self->priv->_toggle_iconify_and_shade;
			if (!_tmp7_) {
				_tmp6_ = TRUE;
			} else {
				_tmp6_ = !self->priv->toggle_state;
			}
			if (_tmp6_) {
				_tmp5_ = TRUE;
			} else {
				_tmp5_ = FALSE;
			}
			showing_desktop = _tmp5_;
			_tmp8_ = scr;
			wnck_screen_toggle_showing_desktop (_tmp8_, showing_desktop);
			wincmd_adjust_toggle_state (self);
			_g_object_unref0 (screen);
			_g_object_unref0 (scr);
			return;
		}
		_g_object_unref0 (screen);
	}
	_tmp9_ = scr;
	_tmp10_ = wnck_screen_get_active_workspace (_tmp9_);
	_tmp11_ = _g_object_ref0 (_tmp10_);
	desk = _tmp11_;
	_tmp12_ = scr;
	_tmp13_ = wnck_screen_get_windows (_tmp12_);
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp13_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* _tmp14_;
			WnckWindow* window = NULL;
			_tmp14_ = _g_object_ref0 ((WnckWindow*) window_it->data);
			window = _tmp14_;
			{
				WnckWindow* _tmp15_;
				WnckWorkspace* _tmp16_;
				_tmp15_ = window;
				_tmp16_ = desk;
				if (wnck_window_is_visible_on_workspace (_tmp15_, _tmp16_)) {
					switch (command) {
						case WINCMD_COMMAND_NONE:
						{
							break;
						}
						case WINCMD_COMMAND_ICONIFY:
						{
							gboolean _tmp17_ = FALSE;
							gboolean _tmp18_;
							_tmp18_ = self->priv->_toggle_iconify_and_shade;
							if (!_tmp18_) {
								_tmp17_ = TRUE;
							} else {
								_tmp17_ = !self->priv->toggle_state;
							}
							if (_tmp17_) {
								WnckWindow* _tmp19_;
								_tmp19_ = window;
								wnck_window_minimize (_tmp19_);
							} else {
								WnckWindow* _tmp20_;
								_tmp20_ = window;
								wnck_window_unminimize (_tmp20_, gtk_get_current_event_time ());
							}
							break;
						}
						case WINCMD_COMMAND_SHADE:
						{
							gboolean _tmp21_ = FALSE;
							gboolean _tmp22_;
							_tmp22_ = self->priv->_toggle_iconify_and_shade;
							if (!_tmp22_) {
								_tmp21_ = TRUE;
							} else {
								_tmp21_ = !self->priv->toggle_state;
							}
							if (_tmp21_) {
								WnckWindow* _tmp23_;
								_tmp23_ = window;
								wnck_window_shade (_tmp23_);
							} else {
								WnckWindow* _tmp24_;
								_tmp24_ = window;
								wnck_window_unshade (_tmp24_);
							}
							break;
						}
						default:
						break;
					}
				}
				_g_object_unref0 (window);
			}
		}
	}
	wincmd_adjust_toggle_state (self);
	_g_object_unref0 (desk);
	_g_object_unref0 (scr);
}

static void
wincmd_adjust_toggle_state (Wincmd* self)
{
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_toggle_iconify_and_shade;
	if (_tmp0_) {
		self->priv->toggle_state = !self->priv->toggle_state;
	} else {
		self->priv->toggle_state = TRUE;
	}
}

static gboolean
wincmd_real_button_release_event (GtkWidget* base,
                                  GdkEventButton* e)
{
	Wincmd * self;
	gboolean _tmp0_ = FALSE;
	gboolean result;
	self = (Wincmd*) base;
	g_return_val_if_fail (e != NULL, FALSE);
	if (e->button == ((guint) 2)) {
		WincmdCommand _tmp1_;
		_tmp1_ = self->priv->_middle_button_command;
		_tmp0_ = _tmp1_ != WINCMD_COMMAND_NONE;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		WincmdCommand _tmp2_;
		_tmp2_ = self->priv->_middle_button_command;
		wincmd_execute_command (self, _tmp2_);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

WincmdCommand
wincmd_get_left_button_command (Wincmd* self)
{
	WincmdCommand result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_left_button_command;
	return result;
}

void
wincmd_set_left_button_command (Wincmd* self,
                                WincmdCommand value)
{
	WincmdCommand old_value;
	g_return_if_fail (self != NULL);
	old_value = wincmd_get_left_button_command (self);
	if (old_value != value) {
		self->priv->_left_button_command = value;
		g_object_notify_by_pspec ((GObject *) self, wincmd_properties[WINCMD_LEFT_BUTTON_COMMAND_PROPERTY]);
	}
}

WincmdCommand
wincmd_get_middle_button_command (Wincmd* self)
{
	WincmdCommand result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_middle_button_command;
	return result;
}

void
wincmd_set_middle_button_command (Wincmd* self,
                                  WincmdCommand value)
{
	WincmdCommand old_value;
	g_return_if_fail (self != NULL);
	old_value = wincmd_get_middle_button_command (self);
	if (old_value != value) {
		self->priv->_middle_button_command = value;
		g_object_notify_by_pspec ((GObject *) self, wincmd_properties[WINCMD_MIDDLE_BUTTON_COMMAND_PROPERTY]);
	}
}

gboolean
wincmd_get_toggle_iconify_and_shade (Wincmd* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_toggle_iconify_and_shade;
	return result;
}

void
wincmd_set_toggle_iconify_and_shade (Wincmd* self,
                                     gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = wincmd_get_toggle_iconify_and_shade (self);
	if (old_value != value) {
		self->priv->_toggle_iconify_and_shade = value;
		g_object_notify_by_pspec ((GObject *) self, wincmd_properties[WINCMD_TOGGLE_ICONIFY_AND_SHADE_PROPERTY]);
	}
}

const gchar*
wincmd_get_icon (Wincmd* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_icon;
	result = _tmp0_;
	return result;
}

void
wincmd_set_icon (Wincmd* self,
                 const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = wincmd_get_icon (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_icon);
		self->priv->_icon = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, wincmd_properties[WINCMD_ICON_PROPERTY]);
	}
}

static void
wincmd_class_init (WincmdClass * klass,
                   gpointer klass_data)
{
	wincmd_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Wincmd_private_offset);
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) wincmd_real_constructed;
	((ValaPanelAppletClass *) klass)->get_settings_ui = (GtkWidget* (*) (ValaPanelApplet*)) wincmd_real_get_settings_ui;
	((GtkWidgetClass *) klass)->button_release_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) wincmd_real_button_release_event;
	G_OBJECT_CLASS (klass)->get_property = _vala_wincmd_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_wincmd_set_property;
	G_OBJECT_CLASS (klass)->finalize = wincmd_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WINCMD_LEFT_BUTTON_COMMAND_PROPERTY, wincmd_properties[WINCMD_LEFT_BUTTON_COMMAND_PROPERTY] = g_param_spec_enum ("left-button-command", "left-button-command", "left-button-command", WINCMD_TYPE_COMMAND, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WINCMD_MIDDLE_BUTTON_COMMAND_PROPERTY, wincmd_properties[WINCMD_MIDDLE_BUTTON_COMMAND_PROPERTY] = g_param_spec_enum ("middle-button-command", "middle-button-command", "middle-button-command", WINCMD_TYPE_COMMAND, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WINCMD_TOGGLE_ICONIFY_AND_SHADE_PROPERTY, wincmd_properties[WINCMD_TOGGLE_ICONIFY_AND_SHADE_PROPERTY] = g_param_spec_boolean ("toggle-iconify-and-shade", "toggle-iconify-and-shade", "toggle-iconify-and-shade", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WINCMD_ICON_PROPERTY, wincmd_properties[WINCMD_ICON_PROPERTY] = g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
wincmd_instance_init (Wincmd * self,
                      gpointer klass)
{
	self->priv = wincmd_get_instance_private (self);
}

static void
wincmd_finalize (GObject * obj)
{
	Wincmd * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WINCMD, Wincmd);
	_g_object_unref0 (self->priv->button);
	_g_object_unref0 (self->priv->image);
	_g_free0 (self->priv->_icon);
	G_OBJECT_CLASS (wincmd_parent_class)->finalize (obj);
}

GType
wincmd_get_type (void)
{
	return wincmd_type_id;
}

GType
wincmd_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (WincmdClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wincmd_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Wincmd), 0, (GInstanceInitFunc) wincmd_instance_init, NULL };
	wincmd_type_id = g_type_module_register_type (module, VALA_PANEL_TYPE_APPLET, "Wincmd", &g_define_type_info, 0);
	Wincmd_private_offset = sizeof (WincmdPrivate);
	return wincmd_type_id;
}

static void
_vala_wincmd_get_property (GObject * object,
                           guint property_id,
                           GValue * value,
                           GParamSpec * pspec)
{
	Wincmd * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WINCMD, Wincmd);
	switch (property_id) {
		case WINCMD_LEFT_BUTTON_COMMAND_PROPERTY:
		g_value_set_enum (value, wincmd_get_left_button_command (self));
		break;
		case WINCMD_MIDDLE_BUTTON_COMMAND_PROPERTY:
		g_value_set_enum (value, wincmd_get_middle_button_command (self));
		break;
		case WINCMD_TOGGLE_ICONIFY_AND_SHADE_PROPERTY:
		g_value_set_boolean (value, wincmd_get_toggle_iconify_and_shade (self));
		break;
		case WINCMD_ICON_PROPERTY:
		g_value_set_string (value, wincmd_get_icon (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_wincmd_set_property (GObject * object,
                           guint property_id,
                           const GValue * value,
                           GParamSpec * pspec)
{
	Wincmd * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WINCMD, Wincmd);
	switch (property_id) {
		case WINCMD_LEFT_BUTTON_COMMAND_PROPERTY:
		wincmd_set_left_button_command (self, g_value_get_enum (value));
		break;
		case WINCMD_MIDDLE_BUTTON_COMMAND_PROPERTY:
		wincmd_set_middle_button_command (self, g_value_get_enum (value));
		break;
		case WINCMD_TOGGLE_ICONIFY_AND_SHADE_PROPERTY:
		wincmd_set_toggle_iconify_and_shade (self, g_value_get_boolean (value));
		break;
		case WINCMD_ICON_PROPERTY:
		wincmd_set_icon (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

void
g_io_wincmd_load (GTypeModule* module)
{
	g_return_if_fail (module != NULL);
	wincmd_register_type (module);
	g_io_extension_point_implement (VALA_PANEL_APPLET_EXTENSION_POINT, TYPE_WINCMD, "org.valapanel.wincmd", 10);
}

void
g_io_wincmd_unload (GIOModule* module)
{
	g_return_if_fail (module != NULL);
}

